﻿Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.IO
Imports System.Threading


Public Class FormMain
    Inherits System.Windows.Forms.Form

    Public client As TcpClient
    Public stream As NetworkStream
    Public sr As StreamReader
    Public connected As Boolean

    
    Private Sub sendCommand(ByVal send As String)
        If Not connected Then
            Return
        End If
        send += vbCrLf
        Dim data As [Byte]() = Encoding.ASCII.GetBytes(send)
        stream.Write(data, 0, data.Length)
    End Sub

    Private Function readBack() As String
        If Not connected Then
            Return ""
        End If
        Dim buffer As New StringBuilder
        Dim returnstring As New String("")
        Try
            If sr.Peek Then
                buffer.Append(sr.ReadLine() + vbCrLf)
            End If
            Return buffer.ToString
        Catch
        End Try
        Return ""
    End Function

    Private Sub TimerReceive_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerReceive.Tick
        Dim str As String
        str = readBack()
        If str.IndexOf("Ch0=") = -1 Then Return

        TextBoxCh0.Text = parseAux0(str).ToString
        TextBoxCh1.Text = parseAux1(str).ToString

    End Sub

    Private Function parseAux0(ByVal s As String) As Double
        Dim toconvert As String
        Try
            s = s.Replace(",", "")
            s = s.Replace(".", ",")
            toconvert = s.Substring(s.IndexOf("Ch0=") + 4, 9)
            Return Double.Parse(toconvert)
        Catch
            Return 0
        End Try
    End Function

    Private Function parseAux1(ByVal s As String) As Double
        'Dim istart As Integer, istop As Integer
        Dim toconvert As String
        Try
            s = s.Replace(",", "")
            s = s.Replace(".", ",")
            toconvert = s.Substring(s.IndexOf("Ch1=") + 4, 9)
            Return Double.Parse(toconvert)
        Catch
            Return 0
        End Try
    End Function

    Private Sub FormMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        sr.Close()
    End Sub

    Private Sub FormMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try
            client = New TcpClient("localhost", "8005")
            stream = client.GetStream()
            sr = New StreamReader(stream)
            connected = True
            stream.ReadTimeout = 100
            Thread.Sleep(1000)
            Dim devstr As String = "DEV316"
            Label3.Text = devstr
            sendCommand("cd " + devstr)
            sendCommand("auxins/0/averaging 32768")
        Catch
            MsgBox("Error connecting to HF2")
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSubscribe.Click
        sendCommand("subs auxins/0/sample")
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonUnsubscribe.Click
        sendCommand("unsubs auxins/0/sample")
    End Sub
End Class







